(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-sortgrid', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng-sortgrid'] = {}, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, i0, rxjs, operators, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var NgsgElementsHelper = /** @class */ (function () {
        function NgsgElementsHelper() {
        }
        NgsgElementsHelper.findIndex = function (element) {
            var allElements = element.parentNode.children;
            return Array.prototype.indexOf.call(allElements, element);
        };
        return NgsgElementsHelper;
    }());

    var ScrollHelperService = /** @class */ (function () {
        function ScrollHelperService(document) {
            this.document = document;
            this.DEFAULT_SCROLLSPEED = 50;
            this.SCROLL_BUFFER = 50;
            this.window = document.defaultView;
        }
        ScrollHelperService.prototype.scrollIfNecessary = function (event, scrollPoints, scrollSpeed) {
            if (scrollPoints === void 0) { scrollPoints = {}; }
            var currentPosition = event.pageY - this.window.scrollY;
            if (this.isTopScrollNeeded(currentPosition, scrollPoints.top)) {
                this.window.scrollBy({ top: -scrollSpeed || -this.DEFAULT_SCROLLSPEED, behavior: 'smooth' });
                return;
            }
            if (this.isBottomScrollNeeded(currentPosition, scrollPoints.bottom)) {
                this.window.scrollBy({ top: scrollSpeed || this.DEFAULT_SCROLLSPEED, behavior: 'smooth' });
            }
        };
        ScrollHelperService.prototype.isTopScrollNeeded = function (currentPosition, scrollPointTop) {
            return scrollPointTop ? currentPosition < scrollPointTop :
                currentPosition < this.SCROLL_BUFFER;
        };
        ScrollHelperService.prototype.isBottomScrollNeeded = function (currentPosition, scrollPointBottom) {
            return scrollPointBottom ? currentPosition > scrollPointBottom :
                currentPosition > this.window.innerHeight - this.SCROLL_BUFFER;
        };
        return ScrollHelperService;
    }());
    /** @nocollapse */ ScrollHelperService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function ScrollHelperService_Factory() { return new ScrollHelperService(i0__namespace.ɵɵinject(i1__namespace.DOCUMENT)); }, token: ScrollHelperService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    ScrollHelperService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /**
     * @type {function(): !Array<(null|{
     *   type: ?,
     *   decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>),
     * })>}
     * @nocollapse
     */
    ScrollHelperService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };

    var NgsgClassService = /** @class */ (function () {
        function NgsgClassService() {
            this.SELECTED_DEFAULT_CLASS = 'ng-sg-selected';
            this.PLACEHOLDER_DEFAULT_CLASS = 'ng-sg-placeholder';
            this.DROPPED_DEFAULT_CLASS = 'ng-sg-dropped';
            this.ACTIVE_DEFAULT_CLASS = 'ng-sg-active';
        }
        NgsgClassService.prototype.addPlaceHolderClass = function (element) {
            element.classList.add(this.PLACEHOLDER_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.removePlaceHolderClass = function (element) {
            element.classList.remove(this.PLACEHOLDER_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.addDroppedClass = function (element) {
            element.classList.add(this.DROPPED_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.removeDroppedClass = function (element) {
            element.classList.remove(this.DROPPED_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.addSelectedClass = function (element) {
            element.classList.add(this.SELECTED_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.removeSelectedClass = function (element) {
            element.classList.remove(this.SELECTED_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.addActiveClass = function (element) {
            element.classList.add(this.ACTIVE_DEFAULT_CLASS);
        };
        NgsgClassService.prototype.removeActiveClass = function (element) {
            element.classList.remove(this.ACTIVE_DEFAULT_CLASS);
        };
        return NgsgClassService;
    }());
    /** @nocollapse */ NgsgClassService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgsgClassService_Factory() { return new NgsgClassService(); }, token: NgsgClassService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgClassService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    var NgsgStoreService = /** @class */ (function () {
        function NgsgStoreService() {
            this.state = new Map();
        }
        NgsgStoreService.prototype.initState = function (group, items, classes) {
            if (items === void 0) { items = []; }
            if (classes === void 0) { classes = {}; }
            this.state.set(group, { items: __spreadArray([], __read(items)), classes: classes, selectedItems: [] });
        };
        NgsgStoreService.prototype.addSelectedItem = function (group, dragElement) {
            this.state.get(group).selectedItems.push(dragElement);
        };
        NgsgStoreService.prototype.removeSelectedItem = function (group, item) {
            var updatedItems = this.state.get(group).selectedItems
                .filter(function (dragElement) { return dragElement.node !== item; });
            this.setSelectedItems(group, updatedItems);
        };
        NgsgStoreService.prototype.setItems = function (group, items) {
            this.state.get(group).items = __spreadArray([], __read(items));
        };
        NgsgStoreService.prototype.getItems = function (group) {
            return this.state.get(group).items;
        };
        NgsgStoreService.prototype.hasItems = function (group) {
            return this.getItems(group).length > 0;
        };
        NgsgStoreService.prototype.hasGroup = function (group) {
            return this.state.has(group);
        };
        NgsgStoreService.prototype.getSelectedItems = function (group) {
            return this.state.get(group).selectedItems;
        };
        NgsgStoreService.prototype.setSelectedItems = function (group, selectedItems) {
            this.state.get(group).selectedItems = __spreadArray([], __read(selectedItems));
        };
        NgsgStoreService.prototype.getFirstSelectItem = function (group) {
            return this.state.get(group).selectedItems[0];
        };
        NgsgStoreService.prototype.hasSelectedItems = function (group) {
            return this.getSelectedItems(group).length > 0;
        };
        NgsgStoreService.prototype.resetSelectedItems = function (group) {
            this.setSelectedItems(group, []);
        };
        NgsgStoreService.prototype.getClasses = function (group) {
            return this.state.get(group).classes;
        };
        return NgsgStoreService;
    }());
    /** @nocollapse */ NgsgStoreService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgsgStoreService_Factory() { return new NgsgStoreService(); }, token: NgsgStoreService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgStoreService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    var ChangeAction;
    (function (ChangeAction) {
        ChangeAction[ChangeAction["ADD"] = 0] = "ADD";
        ChangeAction[ChangeAction["REMOVE"] = 1] = "REMOVE";
    })(ChangeAction || (ChangeAction = {}));
    var NgsgSelectionService = /** @class */ (function () {
        function NgsgSelectionService(classService, ngsgStore) {
            var _this = this;
            this.classService = classService;
            this.ngsgStore = ngsgStore;
            this.COMMAND_KEY = 'Meta';
            this.CONTROL_KEY = 'Control';
            this.selectionChange$ = new rxjs.Subject();
            var selectionKeyPressed$ = this.selectionKeyPressed();
            this.selectionChange$
                .pipe(operators.withLatestFrom(selectionKeyPressed$))
                .subscribe(function (_a) {
                var _b = __read(_a, 2), selectionChange = _b[0], selectionKeyPressed = _b[1];
                selectionKeyPressed
                    ? _this.handleSelectionChange(selectionChange)
                    : _this.resetSelectedItems(selectionChange.key);
            });
        }
        NgsgSelectionService.prototype.resetSelectedItems = function (group) {
            var _this = this;
            this.ngsgStore.getSelectedItems(group).forEach(function (item) { return _this.classService.removeSelectedClass(item.node); });
            this.ngsgStore.resetSelectedItems(group);
        };
        NgsgSelectionService.prototype.handleSelectionChange = function (selectionChange) {
            if (selectionChange.action === ChangeAction.ADD) {
                this.classService.addSelectedClass(selectionChange.item);
                this.ngsgStore.addSelectedItem(selectionChange.key, {
                    node: selectionChange.item,
                    originalIndex: NgsgElementsHelper.findIndex(selectionChange.item)
                });
            }
            if (selectionChange.action === ChangeAction.REMOVE) {
                this.classService.removeSelectedClass(selectionChange.item);
                this.ngsgStore.removeSelectedItem(selectionChange.key, selectionChange.item);
            }
        };
        NgsgSelectionService.prototype.selectionKeyPressed = function () {
            var _this = this;
            var selectionKeyPressed = rxjs.fromEvent(window, 'keydown').pipe(operators.filter(function (keyboardEvent) { return keyboardEvent.key === _this.COMMAND_KEY || keyboardEvent.key === _this.CONTROL_KEY; }), operators.mapTo(true));
            var keyup = rxjs.fromEvent(window, 'keyup').pipe(operators.mapTo(false));
            return rxjs.merge(selectionKeyPressed, keyup);
        };
        NgsgSelectionService.prototype.selectElementIfNoSelection = function (group, dragedElement) {
            if (this.ngsgStore.hasSelectedItems(group)) {
                return;
            }
            this.ngsgStore.addSelectedItem(group, {
                node: dragedElement,
                originalIndex: NgsgElementsHelper.findIndex(dragedElement)
            });
        };
        NgsgSelectionService.prototype.updateSelectedDragItem = function (key, item, selected) {
            this.selectionChange$.next({
                key: key,
                item: item,
                action: selected ? ChangeAction.ADD : ChangeAction.REMOVE
            });
        };
        return NgsgSelectionService;
    }());
    /** @nocollapse */ NgsgSelectionService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgsgSelectionService_Factory() { return new NgsgSelectionService(i0__namespace.ɵɵinject(NgsgClassService), i0__namespace.ɵɵinject(NgsgStoreService)); }, token: NgsgSelectionService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgSelectionService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /**
     * @type {function(): !Array<(null|{
     *   type: ?,
     *   decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>),
     * })>}
     * @nocollapse
     */
    NgsgSelectionService.ctorParameters = function () { return [
        { type: NgsgClassService },
        { type: NgsgStoreService }
    ]; };

    var NgsgEventsService = /** @class */ (function () {
        function NgsgEventsService() {
            this.dropped$ = new rxjs.Subject();
        }
        return NgsgEventsService;
    }());
    /** @nocollapse */ NgsgEventsService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgsgEventsService_Factory() { return new NgsgEventsService(); }, token: NgsgEventsService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgEventsService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    var NgsgReflectService = /** @class */ (function () {
        function NgsgReflectService(ngsgStore) {
            this.ngsgStore = ngsgStore;
        }
        NgsgReflectService.prototype.reflectChanges = function (key, element) {
            var items = this.ngsgStore.getItems(key);
            var selectedElements = this.ngsgStore.getSelectedItems(key);
            var selectedElementIndices = this.getSelectedElementsIndices(selectedElements);
            var selectedItems = this.getSelectedItems(items, selectedElementIndices);
            var sortedIndices = selectedElementIndices.sort();
            var dropIndex = this.findDropIndex(selectedElements, element);
            while (sortedIndices.length > 0) {
                items.splice(sortedIndices.pop(), 1);
            }
            var result = this.getReflectedItems(items, selectedItems, dropIndex);
            this.ngsgStore.setItems(key, result);
            return result;
        };
        NgsgReflectService.prototype.getReflectedItems = function (items, selectedItems, dropIndex) {
            var beforeSelection = items.slice(0, dropIndex);
            var afterSelection = items.slice(dropIndex, items.length);
            return __spreadArray(__spreadArray(__spreadArray([], __read(beforeSelection)), __read(selectedItems)), __read(afterSelection));
        };
        NgsgReflectService.prototype.getSelectedItems = function (items, selectedElementIndexes) {
            var selectedItems = [];
            selectedElementIndexes.forEach(function (index) {
                selectedItems.push(items[index]);
            });
            return selectedItems;
        };
        NgsgReflectService.prototype.getSelectedElementsIndices = function (selectedElements) {
            return selectedElements.map(function (selectedElement) { return selectedElement.originalIndex; });
        };
        NgsgReflectService.prototype.findDropIndex = function (selectedElements, element) {
            if (this.isDropInSelection(selectedElements, element)) {
                return NgsgElementsHelper.findIndex(selectedElements[0].node);
            }
            return NgsgElementsHelper.findIndex(element);
        };
        NgsgReflectService.prototype.isDropInSelection = function (collection, dropElement) {
            return !!collection.find(function (dragElment) { return dragElment.node === dropElement; });
        };
        return NgsgReflectService;
    }());
    /** @nocollapse */ NgsgReflectService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgsgReflectService_Factory() { return new NgsgReflectService(i0__namespace.ɵɵinject(NgsgStoreService)); }, token: NgsgReflectService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgReflectService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /**
     * @type {function(): !Array<(null|{
     *   type: ?,
     *   decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>),
     * })>}
     * @nocollapse
     */
    NgsgReflectService.ctorParameters = function () { return [
        { type: NgsgStoreService }
    ]; };

    var NgsgSortService = /** @class */ (function () {
        function NgsgSortService(classService, ngsgStore) {
            this.classService = classService;
            this.ngsgStore = ngsgStore;
        }
        NgsgSortService.prototype.initSort = function (group) {
            this.dragIndex = this.ngsgStore.getFirstSelectItem(group).originalIndex;
            this.dragElements = this.ngsgStore.getSelectedItems(group);
        };
        NgsgSortService.prototype.sort = function (dropElement) {
            var _this = this;
            var hoverIndex = NgsgElementsHelper.findIndex(dropElement);
            var el = this.getSibling(dropElement, this.dragIndex, hoverIndex);
            if (this.isDropInSelection(el)) {
                return;
            }
            this.dragElements.forEach(function (dragElement) {
                var insertedNode = dropElement.parentNode.insertBefore(dragElement.node, el.node);
                _this.classService.addPlaceHolderClass(insertedNode);
            });
            this.dragIndex = NgsgElementsHelper.findIndex(this.dragElements[0].node);
        };
        NgsgSortService.prototype.endSort = function () {
            var _this = this;
            this.dragElements.forEach(function (dragElement) {
                _this.updateDropedItem(dragElement.node);
            });
        };
        NgsgSortService.prototype.getSibling = function (dropElement, dragIndex, hoverIndex) {
            if (dragIndex < hoverIndex) {
                return { node: dropElement.nextSibling, originalIndex: hoverIndex + 1 };
            }
            return { node: dropElement, originalIndex: hoverIndex };
        };
        NgsgSortService.prototype.isDropInSelection = function (dropElement) {
            return !!this.dragElements.find(function (dragElment) { return dragElment.node === dropElement.node; });
        };
        NgsgSortService.prototype.updateDropedItem = function (item) {
            var _this = this;
            this.classService.removePlaceHolderClass(item);
            this.classService.addDroppedClass(item);
            this.classService.removeSelectedClass(item);
            this.classService.removeActiveClass(item);
            rxjs.timer(500).subscribe(function () { return _this.classService.removeDroppedClass(item); });
        };
        return NgsgSortService;
    }());
    /** @nocollapse */ NgsgSortService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgsgSortService_Factory() { return new NgsgSortService(i0__namespace.ɵɵinject(NgsgClassService), i0__namespace.ɵɵinject(NgsgStoreService)); }, token: NgsgSortService, providedIn: "root" });
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgSortService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /**
     * @type {function(): !Array<(null|{
     *   type: ?,
     *   decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>),
     * })>}
     * @nocollapse
     */
    NgsgSortService.ctorParameters = function () { return [
        { type: NgsgClassService },
        { type: NgsgStoreService }
    ]; };

    var NgsgDragHandleDirective = /** @class */ (function () {
        function NgsgDragHandleDirective(el) {
            this.el = el;
        }
        return NgsgDragHandleDirective;
    }());
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgDragHandleDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngSortgridDragHandle]'
                },] }
    ];
    /**
     * @type {function(): !Array<(null|{
     *   type: ?,
     *   decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>),
     * })>}
     * @nocollapse
     */
    NgsgDragHandleDirective.ctorParameters = function () { return [
        { type: i0.ElementRef }
    ]; };

    var selector = '[ngSortgridItem]';
    var NgsgItemDirective = /** @class */ (function () {
        function NgsgItemDirective(el, sortService, selectionService, reflectService, ngsgStore, ngsgEventService, scrollHelperService, classService) {
            this.el = el;
            this.sortService = sortService;
            this.selectionService = selectionService;
            this.reflectService = reflectService;
            this.ngsgStore = ngsgStore;
            this.ngsgEventService = ngsgEventService;
            this.scrollHelperService = scrollHelperService;
            this.classService = classService;
            this.ngSortGridGroup = 'defaultGroup';
            this.autoScroll = false;
            this.sorted = new i0.EventEmitter();
            this.selected = false;
            this.destroy$ = new rxjs.Subject();
        }
        NgsgItemDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.ngsgEventService.dropped$.pipe(operators.takeUntil(this.destroy$)).subscribe(function () { return _this.selected = false; });
            rxjs.fromEvent(this.el.nativeElement, 'drag').pipe(operators.throttleTime(20), operators.takeUntil(this.destroy$), operators.takeWhile(function () { return _this.autoScroll; })).subscribe(function () {
                _this.scrollHelperService.scrollIfNecessary(event, {
                    top: _this.scrollPointTop,
                    bottom: _this.scrollPointBottom
                }, _this.scrollSpeed);
            });
        };
        NgsgItemDirective.prototype.ngOnChanges = function (changes) {
            var sortGridItemChanges = changes.ngSortGridItems;
            var sortGridItems = sortGridItemChanges.currentValue ? sortGridItemChanges.currentValue : [];
            if (!this.ngsgStore.hasGroup(this.ngSortGridGroup)) {
                this.ngsgStore.initState(this.ngSortGridGroup, sortGridItems);
                return;
            }
            this.ngsgStore.setItems(this.ngSortGridGroup, sortGridItems);
        };
        NgsgItemDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            var _a, _b;
            this.handleElement = ((_b = (_a = this.handle) === null || _a === void 0 ? void 0 : _a.el) === null || _b === void 0 ? void 0 : _b.nativeElement) || this.el.nativeElement;
            rxjs.fromEvent(this.handleElement, 'mousedown').pipe(operators.takeUntil(this.destroy$)).subscribe(function () {
                _this.el.nativeElement.draggable = true;
            });
        };
        NgsgItemDirective.prototype.ngOnDestroy = function () {
            this.destroy$.next();
            this.destroy$.complete();
        };
        NgsgItemDirective.prototype.dragStart = function (event) {
            if (!this.occuredOnHost(event)) {
                return;
            }
            this.selectionService.selectElementIfNoSelection(this.ngSortGridGroup, event.target);
            this.classService.addActiveClass(event.target);
            this.sortService.initSort(this.ngSortGridGroup);
        };
        NgsgItemDirective.prototype.dragEnter = function () {
            if (!this.ngsgStore.hasSelectedItems(this.ngSortGridGroup)) {
                return;
            }
            this.sortService.sort(this.el.nativeElement);
        };
        NgsgItemDirective.prototype.dragOver = function (event) {
            if (event.preventDefault) {
                // Necessary. Allows us to drop.
                event.preventDefault();
            }
            return false;
        };
        NgsgItemDirective.prototype.drop = function () {
            this.el.nativeElement.draggable = false;
            if (!this.ngsgStore.hasSelectedItems(this.ngSortGridGroup)) {
                return;
            }
            if (!this.ngsgStore.hasItems(this.ngSortGridGroup)) {
                console.warn("Ng-sortgrid: No items provided - please use [sortGridItems] to pass in an array of items -\n      otherwhise the ordered items can not be emitted in the (sorted) event");
                return;
            }
            var previousOrder = __spreadArray([], __read(this.ngsgStore.getItems(this.ngSortGridGroup)));
            this.sortService.endSort();
            var currentOrder = this.reflectService.reflectChanges(this.ngSortGridGroup, this.el.nativeElement);
            this.sorted.next({ previousOrder: previousOrder, currentOrder: currentOrder });
            this.ngsgStore.resetSelectedItems(this.ngSortGridGroup);
            this.ngsgEventService.dropped$.next();
        };
        NgsgItemDirective.prototype.clicked = function () {
            this.selected = !this.isItemCurrentlySelected();
            this.selectionService.updateSelectedDragItem(this.ngSortGridGroup, this.el.nativeElement, this.selected);
        };
        NgsgItemDirective.prototype.isItemCurrentlySelected = function () {
            var index = NgsgElementsHelper.findIndex(this.el.nativeElement);
            return !!this.ngsgStore.getSelectedItems(this.ngSortGridGroup)
                .find(function (element) { return element.originalIndex === index; });
        };
        NgsgItemDirective.prototype.occuredOnHost = function (event) {
            return event.target.matches(selector);
        };
        return NgsgItemDirective;
    }());
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgItemDirective.decorators = [
        { type: i0.Directive, args: [{ selector: selector },] }
    ];
    /**
     * @type {function(): !Array<(null|{
     *   type: ?,
     *   decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>),
     * })>}
     * @nocollapse
     */
    NgsgItemDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: NgsgSortService },
        { type: NgsgSelectionService },
        { type: NgsgReflectService },
        { type: NgsgStoreService },
        { type: NgsgEventsService },
        { type: ScrollHelperService },
        { type: NgsgClassService }
    ]; };
    /** @type {!Object<string, !Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    NgsgItemDirective.propDecorators = {
        ngSortGridGroup: [{ type: i0.Input }],
        ngSortGridItems: [{ type: i0.Input }],
        scrollPointTop: [{ type: i0.Input }],
        scrollPointBottom: [{ type: i0.Input }],
        scrollSpeed: [{ type: i0.Input }],
        autoScroll: [{ type: i0.Input }],
        sorted: [{ type: i0.Output }],
        handle: [{ type: i0.ContentChild, args: [NgsgDragHandleDirective,] }],
        dragStart: [{ type: i0.HostListener, args: ['dragstart', ['$event'],] }],
        dragEnter: [{ type: i0.HostListener, args: ['dragenter',] }],
        dragOver: [{ type: i0.HostListener, args: ['dragover', ['$event'],] }],
        drop: [{ type: i0.HostListener, args: ['dragend',] }],
        clicked: [{ type: i0.HostListener, args: ['click',] }]
    };

    var NgsgModule = /** @class */ (function () {
        function NgsgModule() {
        }
        return NgsgModule;
    }());
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NgsgModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgsgItemDirective, NgsgDragHandleDirective],
                    exports: [NgsgItemDirective, NgsgDragHandleDirective]
                },] }
    ];

    /*
     * Public API Surface of ng-sortgrid
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgsgItemDirective = NgsgItemDirective;
    exports.NgsgModule = NgsgModule;
    exports.ɵa = NgsgDragHandleDirective;
    exports.ɵb = NgsgSortService;
    exports.ɵc = NgsgClassService;
    exports.ɵd = NgsgStoreService;
    exports.ɵe = NgsgSelectionService;
    exports.ɵf = NgsgReflectService;
    exports.ɵg = NgsgEventsService;
    exports.ɵh = ScrollHelperService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-sortgrid.umd.js.map
